//+------------------------------------------------------------------+
//|                                          Envelopes alert mod.mq4 |
//| Use default settings on all GBP pairs H4. First, add a 34        |
//| smoothed MA, price mode: 5, shift: 1. System = enter when new    |
//| candle opens above or below upper/lower band, sl below middle    |
//| band, tp = sl x 2 (break even after sl x 1), max sl = 80,        |
//| otherwise no trade, unless you have really big pockets :-)       |
//+------------------------------------------------------------------+
//http://www.forexfactory.com/showthread.php?p=7578532#post7578532
//////////////////////////////////////////////////////////////////////
// !!! YOU MUST COMPILE THIS EA WITH THE BUILD 509 COMPILER, download the metaeditor for build 509 at http://www.forexfactory.com/showthread.php?t=470340 !!!
//////////////////////////////////////////////////////////////////////
#property copyright "Copyright  ? // mod. Marc (fxdaytrader), http://ForexBaron.net"
#property link      "http://ForexBaron.net"
#property indicator_chart_window

#property indicator_buffers 2

#property indicator_color1 DeepSkyBlue //White
#property indicator_color2 Gold //White
#property indicator_width1 1
#property indicator_width2 1
extern bool Al_upper_price_over = true;
extern bool Alarm_lower_price_below = true;

extern int      LookbackCandles    = 1500;//150;
extern int      MAperiod           = 34;
extern int      MaShift            = 1;
extern int      MAmethod           = 2;
extern int      AppliedPrice       = 5;
//
extern double   DeviationPercent   = 0.25;
//extern int      AlertCandle        = 0;
//extern bool     ChartAlert         = true;
//extern bool     SendNotification   = true; //sends a 'push notification' alert to your android phone

//fxdaytrader:
extern string ahi0=" ******* Alert settings:";
extern int  AlertCandle           = 0;
extern bool PopupAlerts            = TRUE;
extern bool EmailAlerts            = FALSE;
extern bool PushNotificationAlerts = FALSE;
extern bool SoundAlerts            = FALSE;
extern string SoundFileLong        = "alert.wav";
extern string SoundFileShort       = "alert2.wav";
int lastAlert=3;


double   ind_buffer0[], ind_buffer1[];

datetime alert_time;

//+------------------------------------------------------------------+
int init()  {
//+------------------------------------------------------------------+
  SetIndexBuffer(0,ind_buffer0);
  //SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1,DeepSkyBlue);
  SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
  SetIndexDrawBegin(0,0);
  SetIndexLabel(0,"UPPER ENVELOPE");

  SetIndexBuffer(1,ind_buffer1);
  //SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1,Gold);
  SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
  SetIndexLabel(1,"LOWER ENVELOPE");
  SetIndexDrawBegin(1,0);

  alert_time = -9999;
  return(0);
}

//+------------------------------------------------------------------+
int deinit()  {
//+------------------------------------------------------------------+
  return(0);
}

//+------------------------------------------------------------------+
int start()  {
//+------------------------------------------------------------------+
  // Plot envelopes.......
  if (LookbackCandles >= 0)   {
    for (int i=MathMin(Bars-MAperiod,LookbackCandles); i>=0; i--)   {
      ind_buffer0[i] = iEnvelopes(NULL,0,MAperiod,MAmethod,MaShift,AppliedPrice,DeviationPercent,1,i); //symbol,tf, MA period, MA method, MA shift, MA price, deviation (%),line index,shift 
      ind_buffer1[i] = iEnvelopes(NULL,0,MAperiod,MAmethod,MaShift,AppliedPrice,DeviationPercent,2,i);    
  } }    
  // Alerts.......
  double upper = iEnvelopes(NULL,0,MAperiod,MAmethod,MaShift,AppliedPrice,DeviationPercent,1,AlertCandle);
  double lower = iEnvelopes(NULL,0,MAperiod,MAmethod,MaShift,AppliedPrice,DeviationPercent,2,AlertCandle);
  if (Close[AlertCandle] > upper) 
  
  
   {
    if (Time[0] > alert_time)
    if ( Al_upper_price_over==true)  {
      alert_time = Time[0];
      /*
      string alert_text = Symbol() + "," + TFToStr(Period()) + ":  Above upper envelope";
      if (ChartAlert)          Alert(alert_text);
      if (SendNotification)   SendNotification("Upper Envelope Break! " + Symbol());
      */
      doAlerts("Above upper envelope",SoundFileLong);
  } }
  if (Close[AlertCandle] < lower)
  if ( Alarm_lower_price_below==true)  {
    if (Time[0] > alert_time)  {
      alert_time = Time[0];
      /*
      alert_text = Symbol() + "," + TFToStr(Period()) + ":  Below lower envelope";
      if (ChartAlert)          Alert(alert_text);
      if (SendNotification)   SendNotification("Lower Envelope Break! " + Symbol());
      */
      doAlerts("Below lower envelope",SoundFileShort);
  } }
  return(0);
}

/*
string TFToStr(int tf)
//+------------------------------------------------------------------+
// Converts a MT4-numeric timeframe to its descriptor string
// Usage:   string s=TFToStr(15) returns s="M15"
{
  switch (tf)  {
    case     1 :  return("M1");
    case     5 :  return("M5");
    case    15 :  return("M15");
    case    30 :  return("M30");
    case    60 :  return("H1");
    case   240 :  return("H4");
    case  1440 :  return("D1");
    case 10080 :  return("W1");
    case 43200 :  return("MN");
  }  
  return("");
}  
*/

//fxdaytrader:
//+------------------------------------------------------------------+

void doAlerts(string msg,string SoundFile) {
        msg="Envelopes  Alert on "+Symbol()+", period "+TFtoStr(Period())+": "+msg;//+", bid = "+DoubleToStr(MarketInfo(Symbol(),MODE_BID),Digits)+", servertime: "+TimeToStr(TimeCurrent());
 string emailsubject="MT4 alert on acc. "+AccountNumber()+", "+WindowExpertName()+" - Alert on "+Symbol()+", period "+TFtoStr(Period());
  if (PopupAlerts) Alert(msg);
  if (EmailAlerts) SendMail(emailsubject,msg);
  if (PushNotificationAlerts) SendNotification(msg);
  if (SoundAlerts) PlaySound(SoundFile);
}//void doAlerts(string msg,string SoundFile) {

string TFtoStr(int period) {
 if (period==0) period=Period();
 switch(period) {
  case 1     : return("M1");  break;
  case 5     : return("M5");  break;
  case 15    : return("M15"); break;
  case 30    : return("M30"); break;
  case 60    : return("H1");  break;
  case 240   : return("H4");  break;
  case 1440  : return("D1");  break;
  case 10080 : return("W1");  break;
  case 43200 : return("MN1"); break;
  default    : return(DoubleToStr(period,0));
 }
 return("UNKNOWN");
}//string TFtoStr(int period) {

